<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Modification "cpo_news"	                                     |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: beta2 / June 2012 ==

*/

if (!defined('CPO')) exit;
$translator->addTranslation('cart', CPO_BASEDIR.'mod_cart/lang');
if ($directory == 'mod_cart') $translator->addTranslation('login', CPO_BASEDIR.'mod_cart/lang');

if (!function_exists('modHelp'))  {
	function modHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

$GLOBALS['modules']['cart'] = array(
    'directory' => $moduleDirectory,
    'caption'   => __('Cart'),
    'install'   => 'function: cpo_cart_install',
    'activate'  => 'function: cpo_cart_activate',
    'deactivate'=> 'function: cpo_cart_deactivate',
    'uninstall' => 'function: cpo_cart_uninstall '.$moduleDirectory,
    'manage'	=> 'function: cpo_cart_manage',
	'owner'		=> $cpoSystem['owner'],
	'lkey'		=> '',
	'mod_id'	=> 26,
	//Help ***********************************+
	'helptoc' => array(
        'bersicht' 
			=> modHelp('index','cart'),
        '1. Eigenschaften' 
			=> modHelp('features','cart'),
        '2. Installation' 
			=> modHelp('setup','cart'),
        '3. Einstellungen' 
			=> modHelp('settings','cart'),
        '3.1 Templates' 
			=> modHelp('templates','cart'),
        '3.2 Textbausteine' 
			=> modHelp('blocks','cart'),
        '4. Anwendung' 
			=> modHelp('application','cart')
	),

	'sender' => $cpoSystem['admin_email'],
	'recipient'=> $cpoSystem['admin_email'],
	'customers_rubric' => 0,
	'orders_rubric'  => 0,
	'cart_text_rubric'  => 0,

	'calcShipping'  => 'yes',
	'free_shipping'  => '',
	'estShipping'  => '',
	'shipping_rates'  => "DHL-Paket 2kg;2000;4.90\nDHL-Paket 10kg;10000;5.90\nDHL-Paket 20kg;20000;10.90\nDHL-Paket 31,5kg;31500;12.90",
	'currency'  => 'Euro',
	'weightUnit'  => '1000#kg',
	'decimal'  => 'komma',
	'shippingTax'  => 'relvalue',

	'customer_template'  => 0,
	'cartrow_template'  => 0,
	'checkout_template'  => 0,

	'pagetemplate_cart'  => 0,
	'pagetemplate_billing'  => 0,
	'pagetemplate_shipping'  => 0,
	'pagetemplate_checkout'  => 0,
	'pagetemplate_confirmation'  => 0,

	'form_directory'  => 'mod_form',
	'ph_item'  => 'Artikelnummer',
	'ph_weight'  => 'Gewicht',
	'ph_tax'  => 'Steuersatz',
	'ph_price'  => 'Preis',
	'ph_max'  => 'Maximale Anzahl',
	'ph_options'  => 'Optionen;Varianten;Aufpreise',

	'button_refresh'  => '<a href="%s" title="aktualisieren"><img src="../mod_cart/pics/reload.gif" border="0" alt="aktualisieren" /></a>',
	'button_delete'  => '<a href="%s" title="lschen"><img src="../mod_cart/pics/delete.gif" border="0" alt="lschen" /></a>',
	'css_sheet'  => '../_cfg/style.css.dist',
	'billdata_form'  => "submit: Kundendaten fr diese Bestellung speichern\nsuccessMessage: Ihre Daten wurden fr diese Bestellung gespeichert! Sie knnen nun die weiteren Schritte durchfhren. Am Ende des Bestellprozesses knnen Sie die Daten als Kundenkonto fr sptere Einkufe und Abruf ihrer Bestellhistorie speichern.\nreset: Abbrechen\ndefaultError: Bitte prfen Sie die eingegebenen Daten! Die mit Sternchen (*) versehenen Felder sind Pflichtfelder, die wahrheitsgem ausgefllt werden mssen. Bei Fragen kontaktieren Sie uns bitte.",
	'checkout_form'  => "submit: Bestellung absenden\nsuccessMessage: Bestellung erfolgreich abgesendet.\ndefaultError: Bitte berprfen Sie Ihre Angaben! Ohne Zustimmung zu den AGB und Kenntnisnahme der Widerrufsbelehrung knnen Sie bei uns nichts bestellen. Bei Fragen kontaktieren Sie uns bitte.",

	'' => ''
	);

function log_cpo_cart()  {
	global $cpoSystem;
	@mail('conpresso@gmx.de','Das Modul CART wurde unter '.BASE_ABS.' installiert','','From: '.$cpoSystem['admin_email']);
}

function cpo_cart_install()
{
	global $dbPrefix, $db;
	include (CPO_BASEDIR.'mod_cart/includes/setup.inc.php');
	$cartdb = new DB;
	$cartdb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('cart', '".serialize(array("installed"=>time()))."', '') ");
    $GLOBALS['message'][] = ___('The cart module was successfully installed!');
	log_cpo_cart();
}

function cpo_cart_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The cart module was removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the cart module.'),$moduleDirectory);

}
function cpo_cart_activate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

	$GLOBALS['message'][] = ___('The cart module got activated.').$reload_navigation;
}

function cpo_cart_deactivate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

	$GLOBALS['message'][] = ___('The cart module got deactivated.').$reload_navigation;
}

function cpo_cart_manage()
{
	global $dbPrefix, $db, $k, $module_status;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.'mod_cart/settings.php"><img src="'.SKIN_URL.'pic_settings.gif" title="'.__('settings').'" alt="'.__('settings').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_settings.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}


function locZahl($zahl) { 
	global $activeModules;
	if ($activeModules['cart']['decimal']=="komma") return number_format($zahl,2,',','.');
	if ($activeModules['cart']['decimal']=="punkt") return number_format($zahl,2,'.',',');
}

function percent($zahl) { 
	return round($zahl*100,0)."%";
}


if (!$activeModules['cart']['installed'])  {
	$cartdb = new DB;
	$cartQuery = "SELECT options FROM ".CPO_OPTION." WHERE type='cart' ORDER BY id ASC LIMIT 0,1";
	$cartdb->query($cartQuery);
	if ($cartdb->num_rows() <= 0)  {
		$cartdb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('cart', '".serialize(array("installed"=>time()))."', '') ");
		$cartdb->query($cartQuery);
	}
	while ($cartdb->next_record()) {
		$options = $cartdb->v('options');
		$cartOpt = unserialize($options);
		if (!is_array($cartOpt)) break;
		foreach ($cartOpt as $key=>$v) {
			$activeModules['cart'][$key] = $v;
		}
	}
}

if (	license($activeModules['cart']['lkey'],$activeModules['cart']['mod_id']) != 1 &&
		license($activeModules['cart']['lkey'],$activeModules['cart']['mod_id']) != 3 &&
		$activeModules['cart']['installed']<(time()-90*24*60*60) && 
		!isset($_POST['go']) &&
		@file_exists(CPO_BASEDIR.$activeModules['cart']['directory'].'/includes/producer.inc.php')
	) 
	{
	include(CPO_BASEDIR.$activeModules['cart']['directory'].'/includes/producer.inc.php');
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($MOD['product'])).'</strong> ';
	$cartbreak = true;
}

if (!$cartbreak)  {
	$hdlr_parser_content['cart']      = array('include: '.urlencode('mod_cart/includes/parser_c_cart.inc.php'));
	$hdlr_parser_replacement['cart']  = array('include: '.urlencode('mod_cart/includes/parser_r_cart.inc.php'));

	function cartBox() {
		global $directory,$activeModules;
		$weightUnitOpt = explode('#',$activeModules['cart']['weightUnit']);
		$weightUnit = $weightUnitOpt[1];
		$weightFactor = (int)$weightUnitOpt[0];
	//	if ($directory == 'mod_cart') return '<!-- No CartBox -->';
		$cartcount = 0;
		$cartval = 0;
		$cartweight = 0;
		$cart_replace = array();
		$cart_with = array();

		$cart=$_COOKIE['shop'];
		if (is_array($cart))  {
			foreach ($cart AS $id=>$item)  {
				if (is_numeric($id)) {
					$itemData = explode("|", $item);
					$cartcount += (int)$itemData[5];
					$cartval += (int)$itemData[5]*(float)$itemData[4];
					$cartweight += (int)$itemData[5]*(float)$itemData[2];
				}
			}
		}
		$cartBoxHTML = getCartHtml('CartBox');
		$cart_replace[] = '### CART_cartcount ###'; $cart_with[] = '<span class="cartcount">'.$cartcount.'</span>'; 
		$cart_replace[] = '### CART_cartweight ###'; $cart_with[] = '<span class="cartweight">'.locZahl($cartweight/$weightFactor).'</span>'; 
		$cart_replace[] = '### CART_cartval ###'; $cart_with[] = '<span class="cartval">'.locZahl($cartval).'</span>'; 
		$cart_replace[] = '### CART_login ###'; $cart_with[] = (isset($_SESSION['SID_log_login_id'])) ? ''.__('Logged in as').': <em>'.$_SESSION['SID_user']['name'].'</em> <a href="member.php?action=logout">'.__('Logout').'</a>' : '<a href="../mod_cart/member.php">Zum Login</a>'; 
		$cartBox = "\n\n<!-- Start CartBox -->\n";
		$cartBox .= str_replace($cart_replace,$cart_with,$cartBoxHTML);
		$cartBox .= "\n<!-- End CartBox -->\n\n";
		return $cartBox;
	}
	function cpoPageCartBox() {
		return cartBox();
	}

	function cartBoxJS() {
		global $activeModules;
		$cartBoxJS = '<script type="text/javascript">'."\n";
		$weightUnitOpt = explode('#',$activeModules['cart']['weightUnit']);
		$weightUnit = $weightUnitOpt[1];
		$weightFactor = (int)$weightUnitOpt[0];
		if ($activeModules['cart']['decimal']=="komma") $cartBoxJS .= "var dec_point = ',';\nvar thousands_sep = '.';\n";
		if ($activeModules['cart']['decimal']=="punkt") $cartBoxJS .= "var dec_point = '.';\nvar thousands_sep = ',';\n";
		$cartBoxJS .= 'var weight_factor = '.$weightFactor.';'."\n";
		$cartBoxJS .= 'var purchase_item_text = "'.addslashes(getCartHtml('ItemPurchase')).'";'."\n";
		$cartBoxJS .= 'var delete_item_text = "'.addslashes(getCartHtml('ItemDelete')).'";'."\n";
		if ($activeModules['cart']['ph_options'])  {
			$cartOptionPHs = explode(";",$activeModules['cart']['ph_options']);
			$PHs = implode($cartOptionPHs,'","');
		}
		$cartBoxJS .= 'var cartOptionPHs = new Array("'.$PHs.'");'."\n";
		$cartBoxJS .= '</script>'."\n";
		$cartBoxJS .= '<script type="text/javascript" src="../mod_cart/includes/cartScripts.js"></script>'."\n";
		return $cartBoxJS;
	}
	function cpoPageCartBoxJS() {
		return cartBoxJS();
	}

	function getCartHtmlText($titel)  {
		global $cpoSystem,$activeModules;

		$query = "SELECT html, keywords FROM ".CPO_CONTENT_HTML.", " . CPO_NEWS . " "
					. "WHERE ".CPO_CONTENT_HTML.".article_id=" . CPO_NEWS . ".nr AND fieldname='HTML-Template' AND " . ( $cpoSystem['release'] ? "artikel_archiv<2 AND freigabe=" . STATE_RELEASED : "artikel_archiv<1 AND freigabe!=" . STATE_BLOCKED ) . " AND pub_datum<='" . date('Y-m-d H:i:s', time()) . "' AND verfallsdatum>='".date('Y-m-d H:i:s', time())."' AND rubric_id=".$activeModules['cart']['cart_text_rubric']." AND titel='".$titel."' "; 
		$db = new DB; 
		$db->query($query); 
		$db->next_record();
		return array('html'=>$db->v('html'),'keywords'=>$db->v('keywords'));
	}
	function getCartHtml($titel)  {
		$theArray = getCartHtmlText($titel);
		return $theArray['html'];
	}

	function cart_navigation($moduleDirectory)
	{
		$GLOBALS['navigation'][__('Cart')][] = array(
				'caption'=>__('Orders'),
				'url'=>BASE_REL.'mod_cart/orders.php'
			);
		$GLOBALS['navigation'][__('Cart')][] = array(
				'caption'=>__('Customers'),
				'url'=>BASE_REL.'mod_cart/customers.php'
			);
		if ($_SESSION['SID_user']['admin'] > ROLE_EDITOR)  {
			$GLOBALS['navigation'][__('Cart')][] = array(
				'caption'=>__('Settings'),
				'url'=>BASE_REL.'mod_cart/settings.php'
			);
		}
	}

	if (!empty($_SESSION['SID_user']['admin'])) {
		$hdlr_navigation[] = 'function: cart_navigation '.$moduleDirectory;
	}

}


?>