<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Cart"(Shop)				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version beta 1 / August 2012 ===

*/

define('FORM',true);

if ($cartbreak) return;

$orgDirectory = $directory;
$weightUnitOpt = explode('#',$activeModules['cart']['weightUnit']);
$weightUnit = $weightUnitOpt[1];
$weightFactor = (int)$weightUnitOpt[0];

// clickstream
echo getCartHtml('ClickStream');

// Warenkorb-Daten aus Cookie einlesen ******************************************************
// cookie = "shop[id]=ordid|name|weight|vat|val|pcs|opt
$taxwghtArray = array();
$taxnumArray = array();
$taxArray = array();
$netArray = array();
$taxes = array();
$cartcount = 0;
$cartval = 0;
$netval = 0;
$taxval = 0;
$cartweight = 0;
$itemIDs[0]=0; // failsafe bei leerem Warenkorb
$cart=$_COOKIE['shop'];
if (is_array($cart))  {
	foreach ($cart AS $id=>$item)  {
		if (is_numeric($id)) {
			$itemData = explode("|", $item);
			$cartcount += (int)$itemData[5];
			$cartval += (int)$itemData[5]*(float)$itemData[4];
			$cartweight += (int)$itemData[5]*(float)$itemData[2];
            $taxwghtArray[$itemData[3]] += (int)$itemData[5]*(float)$itemData[2];
            $taxnumArray[$itemData[3]] += (int)$itemData[5];
			$itemIDs[]=$id;
			$itemNum[$id]=(int)$itemData[5];
            $taxArray[$itemData[3]] += (int)$itemData[5]*(float)$itemData[4]/(1+(float)$itemData[3])*(float)$itemData[3];
            $netArray[$itemData[3]] += (int)$itemData[5]*(float)$itemData[4]/(1+(float)$itemData[3]);
            $taxval += (int)$itemData[5]*(float)$itemData[4]/(1+(float)$itemData[3])*(float)$itemData[3];
            $netval += (int)$itemData[5]*(float)$itemData[4]/(1+(float)$itemData[3]);
		}
	}
}

// Versandkosten berechnen *********************************************
$savecartweight = $cartweight;
$shipping_string = '';
$shipping_string .= sprintf(__('Actually your cart contains:<br />%1$s items with a total weight of %2$s %5$s and a total value of %3$s %4$s.'),
					$cartcount,
					locZahl($cartweight/$weightFactor),
					locZahl($cartval),
					$activeModules['cart']['currency'],
					$weightUnit)
					.'<br><br>';
$total_shipping = 0;
$weight2costArray = array();
$parcels = array();
$parcelList = array();
$shipping_rates = explode("\n",$activeModules['cart']['shipping_rates']);
foreach($shipping_rates AS $rate)  {
    $weight2cost = explode(";",$rate);
    $weight2costArray[$weight2cost[1]] = $weight2cost[2];
    $weight2parcelArray[$weight2cost[1]] = $weight2cost[0];
}
krsort($weight2costArray);
$parcelweightlist = array_keys($weight2costArray);

if ($cartval >= $activeModules['cart']['free_shipping'] && !empty($activeModules['cart']['free_shipping'])) {
    $shipping_string .=  sprintf(__('Shipping is free when the total cart value is higher than %1$s %2$s.'),
							locZahl($activeModules['cart']['free_shipping']),
							$activeModules['cart']['currency'])
							.'<br><br>';
    $total_shipping = 0;
} else if ($activeModules['cart']['calcShipping']=="psch" && !empty($activeModules['cart']['estShipping'])) { // flat-rate shipping
    $shipping_string .=  sprintf(__('Our flat-rate for shipping for every order is %1$s %2$s.'),
							locZahl($activeModules['cart']['estShipping']),
							$activeModules['cart']['currency'])
							.'<br><br>';
    $total_shipping = $activeModules['cart']['estShipping'];
} else {
    $x = 0;
    foreach ($weight2costArray AS $parcelWeight=>$parcelCost)  {
        if ($cartweight <= 0) continue;
        while ($cartweight >= $parcelWeight)  {
            // Paket packen
            $parcels[($parcelWeight)] += 1;
            $cartweight = $cartweight - $parcelWeight;
            $total_shipping = $total_shipping + $parcelCost;
//            $shipping_string .=  '<!-- Wir packen ein '.$weight2parcelArray[$parcelWeight].' '.locZahl($parcelWeight/1000,2).' kg Paket (Rest: '.locZahl($cartweight/1000).' kg)<br /> -->';
        }
        if ( $cartweight < $parcelWeight && $cartweight > $parcelweightlist[$x+1] ) {
            // Restpaket packen
            $parcels[($parcelWeight)] += 1;
            $cartweight = $cartweight - $parcelWeight;
            $total_shipping = $total_shipping + $parcelCost;
 //           $shipping_string .=  '<!-- Wir packen ein '.$weight2parcelArray[$parcelWeight].' '.locZahl($parcelWeight/1000,2).' kg Paket (Rest: '.locZahl($cartweight/1000).' kg)<br /> -->';
        }
        $x++;
    }

//    $shipping_string .=  'Ihre Versandkosten betragen '.locZahl($total_shipping).' Euro.<br>';
    $shipping_string .=  sprintf(__('Your shipping cost is %1$s %2$s.'),locZahl($total_shipping),$activeModules['cart']['currency']).'<br />';
    foreach ($parcels AS $w=>$c)  {
//        $parcelList[] = $c.' x '.$weight2parcelArray[$w].' '.locZahl($w/1000).' kg  '.locZahl($weight2costArray[$w]).' Euro';
        $parcelList[] = sprintf(__('%1$s x "<em>%2$s</em>" %3$s %6$s  %4$s %5$s'), $c, $weight2parcelArray[$w], locZahl($w/$weightFactor), locZahl($weight2costArray[$w]),$activeModules['cart']['currency'],$weightUnit);
    }
    $shipping_string .=  '('.implode(', ',$parcelList).')';
}
$cartweight = $savecartweight;
// Versandkosten-Versteuerung
$string = array();
$parts = array();
$taxes = array();
$shippingTaxCalc = array(
    "none"      => __('none'),
    "main"      => __('Tax rate of the main service'),
    "relvalue"  => __('Proportion to net'),
    "relweight" => __('Proportion to weight'),
    "relcount"  => __('Proportion to number')
    );
$shippingTaxString = __('Shipping costs taxing').': '.$shippingTaxCalc[$activeModules['cart']['shippingTax']].'<br />';
if ($activeModules['cart']['shippingTax']=="none") { $shippingTaxString .= ''; }
if ($activeModules['cart']['shippingTax']=="main") {
    asort($taxArray);
    foreach($taxArray AS $tax=>$val)  {
        $shippingTax = $tax;
        $shippingNet = $total_shipping / (1+$tax);
    }
    $taxes[$tax] = $shippingTax*$shippingNet;
//    $shippingTaxString .= percent($shippingTax).' von netto '.locZahl($shippingNet).' Euro = '.locZahl($shippingTax*$shippingNet).' Euro';
    $shippingTaxString .= sprintf(__('%1$s of net %2$s %4$s = %3$s %4$s'),percent($shippingTax),locZahl($shippingNet),locZahl($shippingTax*$shippingNet),$activeModules['cart']['currency']);
}
if ($activeModules['cart']['shippingTax']=="relvalue") {
    foreach($netArray AS $tax=>$val)  {
        $parts[$tax] = $total_shipping * ($val/array_sum($netArray)) / (1+$tax); //anteilger Nettowert
        $taxes[$tax] = $parts[$tax] * $tax;
//        $string[$tax] = percent($tax).' von netto '.locZahl($parts[$tax]).' Euro = '.locZahl($parts[$tax] * $tax).' Euro';
        $string[$tax] = sprintf(__('%1$s of net %2$s %4$s = %3$s %4$s'),percent($tax),locZahl($parts[$tax]),locZahl($parts[$tax] * $tax),$activeModules['cart']['currency']);
    }
    $shippingTaxString .= implode('<br />',$string);
}
if ($activeModules['cart']['shippingTax']=="relweight") {
    foreach($taxwghtArray AS $tax=>$val)  {
        $parts[$tax] = $total_shipping * ($val/array_sum($taxwghtArray)) / (1+$tax); //anteilges Gewicht
        $taxes[$tax] = $parts[$tax] * $tax;
//        $string[$tax] = percent($tax).' von netto '.locZahl($parts[$tax]).' Euro = '.locZahl($parts[$tax] * $tax).' Euro';
        $string[$tax] = sprintf(__('%1$s of net %2$s %4$s = %3$s %4$s'),percent($tax),locZahl($parts[$tax]),locZahl($parts[$tax] * $tax),$activeModules['cart']['currency']);
    }
    $shippingTaxString .= implode('<br />',$string);
}
if ($activeModules['cart']['shippingTax']=="relcount") {
    foreach($taxnumArray AS $tax=>$val)  {
        $parts[$tax] = $total_shipping * ($val/array_sum($taxnumArray)) / (1+$tax); //anteilge Anzahl
        $taxes[$tax] = $parts[$tax] * $tax;
//        $string[$tax] = percent($tax).' von netto '.locZahl($parts[$tax]).' Euro = '.locZahl($parts[$tax] * $tax).' Euro';
        $string[$tax] = sprintf(__('%1$s of net %2$s %4$s = %3$s %4$s'),percent($tax),locZahl($parts[$tax]),locZahl($parts[$tax] * $tax),$activeModules['cart']['currency']);
    }
    $shippingTaxString .= implode('<br />',$string);
}
$shippingNet = array_sum($parts);








// Hier startet nun die verarbeitung der verschiedenen Steps

$views = array('billdata');  //Kundendaten als Standard

if (!isset($_REQUEST['action'])) $_REQUEST['action'] = 'billdata';

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);


// circle the actions *************************************************

while ($nextaction = array_shift($actions)) {

//	$action = $_REQUEST['action'];

    switch ($nextaction) {

		case 'cart':
			$views = array('cart');
			break; /// }}} cart

		case 'billdata':
		case 'form':
//		default:
			if (isset($_SESSION['SID_log_login_id'])) { 
				$db = new DB;
				$query = "SELECT user, passwd, email "
						."FROM ".CPO_USER.", ".CPO_LOG_LOGIN." " 
						."WHERE ".CPO_USER.".id=".CPO_LOG_LOGIN.".user_id "
						."AND ".CPO_LOG_LOGIN.".id='".addslashes($_SESSION['SID_log_login_id'])."' ";
				$db->query($query);
				if ($db->next_record()) {
					$_REQUEST['username'] = $db->v('user');
					$_REQUEST['password'] = $db->v('passwd');
					$_REQUEST['content']['e-Mail (text)']['text'] = $db->v('email');
				}
			}
			// Verhalten des Formulars steuern
			$directory = $activeModules['cart']['form_directory'];
			$activeModules[$directory]['template'] = $activeModules['cart']['customer_template'];
			$activeModules[$directory]['captcha'] = "no";
			$activeModules[$directory]['upload'] = "no";
			$activeModules[$directory]['rubric'] = -1;
			$activeModules[$directory]['mail'] = "no";
			$activeModules[$directory]['confirmation'] = "none";
			$formSettings = $activeModules['cart']['billdata_form'];
			$formArray = explode("\n",$formSettings);
			foreach($formArray AS $formSettings) {
				$formSetting = explode(':',trim($formSettings));
				$activeModules[$directory][trim($formSetting[0])] = trim($formSetting[1]);
			}
//			print_r($activeModules[$directory]);
//			$activeModules[$directory]['submit'] = "Kundendaten fr diese Bestellung speichern"; // translate this
//			$activeModules[$directory]['successMessage'] = "Daten fr diese Bestellung gespeichert! Sie knnen nun die weiteren Schritte durchfhren."; // translate this
            if (is_array($_SESSION['billdata']) && $_REQUEST['action']!='form') {
                $_REQUEST['content'] = $_SESSION['billdata'];
            } else {
				unset ($_SESSION['billdata']);
				include(CPO_BASEDIR.$directory.'/includes/actions.inc.php');
                if ($_REQUEST['action']=='form' && !$form_error) {
                    $views = array('shipping');
                    $_SESSION['billdata'] = $_REQUEST['content'];
                    break; /// }}} weiter zum shipping
                }
                // Daten eines eingeloggten Users auslesen
                ob_start();
                $query = "SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer "
                            . "FROM " . CPO_NEWS . " "
                            . "WHERE " . ( $cpoSystem['release'] ? "artikel_archiv<2 AND freigabe=" . STATE_RELEASED : "artikel_archiv<1 AND freigabe!=" . STATE_BLOCKED ) . " AND pub_datum<='" . date('Y-m-d H:i:s', time()) . "' AND verfallsdatum>='".date('Y-m-d H:i:s', time())."' AND titel = '".$_REQUEST['content']['e-Mail (text)']['text']."' AND rubric_id=".$activeModules['cart']['customers_rubric']." "; 
                $db = new DB; 
                $db->query($query); 
                while($db->next_record()) { 

                    $db_template      = $db->v('templates_id'); 
                    $db_nr            = $db->v('nr'); 
                    $db_idx           = $db->v('idx'); 
                    $db_email         = $db->v('email'); 
                    $db_autor         = $db->v('autor'); 
                    $db_changer       = $db->v('changer'); 
                    $db_pub_datum     = $db->v('pub_datum'); 
                    $db_verfallsdatum = $db->v('verfallsdatum'); 
                    $db_commentary    = $db->v('commentary'); 
                    $db_titel         = $db->v('titel'); 
                    $db_initial       = $db->v('initial'); 
                    $db_freigabe      = $db->v('freigabe'); 
                    $db_rubric_id     = $db->v('rubric_id');
                    $db_last_modify   = $db->v('last_modify');
                    if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
                        $GLOBALS['lastUpdated'] = strtotime($db_last_modify);
                    }
                    require(CPO_BASEDIR.'_include/select_template.php'); 
                } 
                ob_end_clean ();

                $_REQUEST['content'] = $content;
 //               $_SESSION['billdata'] = $_REQUEST['content'];
            }
			$views = array('billdata');
			break; /// }}} billdata

		case 'shipping':
			if (!$_SESSION['billdata']) {
				$views = array('billdata');
				$actions = array('billdata');
				$message[] = __('Please fill in and save the billing data first for the ordering process!');
				break;
			}
			$views = array('shipping');

			break; /// }}} shipping

		case 'checkout':
			if (!$_SESSION['billdata']) {
				$views = array('billdata');
				$actions = array('billdata');
				$message[] = __('Please fill in and save the billing data first for the ordering process!');
				break;
			}
			$directory = $activeModules['cart']['form_directory'];
			$activeModules[$directory]['template'] = $activeModules['cart']['checkout_template'];
			$activeModules[$directory]['captcha'] = "no";
			$activeModules[$directory]['upload'] = "no";
			$activeModules[$directory]['rubric'] = $activeModules['cart']['orders_rubric'];
			$activeModules[$directory]['mail'] = "no";
			$activeModules[$directory]['confirmation'] = "none";
			$formSettings = $activeModules['cart']['checkout_form'];
			$formArray = explode("\n",$formSettings);
			foreach($formArray AS $formSettings) {
				$formSetting = explode(':',trim($formSettings));
				$activeModules[$directory][trim($formSetting[0])] = trim($formSetting[1]);
			}
			$activeModules[$directory]['submit_template'] = '<input type="submit" class="mod_form_submitbutton" value="'.$activeModules[$directory]['submit'].'" onClick="return innerToHidden();"/><script type="text/javascript">document.getElementById(\'mod_form\').onsubmit=function(){return innerToHidden();};document.getElementById(\'articleData\').value=\'\';document.getElementById(\'customerData\').value=\'\';function innerToHidden() {document.getElementById(\'articleData\').value = document.getElementById(\'checkout_articles\').innerHTML;document.getElementById(\'customerData\').value = document.getElementById(\'checkout_customer\').innerHTML;return true; }</script>'; 

			if ($_REQUEST['formaction']=='checkout')  {
                $_REQUEST['action']='form';
                $_POST['action']='form'; // antiCSRF
                include(CPO_BASEDIR.$directory.'/includes/actions.inc.php');
            }
            if ($_REQUEST['formaction']=='checkout' && !$form_error) {
                $views = array('confirmation');
				$actions = array('confirmation');
				$finalize = true;
                break; /// }}} weiter zum confirmation
            }
            require(CPO_BASEDIR."_include/message.php");
			$views = array('checkout');

			break; /// }}} checkout

		case 'confirmation':
			if (!$_SESSION['billdata']) {
				$views = array('billdata');
				$actions = array('billdata');
				$message[] = __('Please fill in and save the billing data first for the ordering process!');
				break;
			}
			if ($finalize)  {
				// bei erfolgreichem Versand:
				// Warenkorb lschen ... done
                if (is_array($_COOKIE['shop'])) foreach ($_COOKIE['shop'] AS $key=>$val) setcookie ('shop['.$key.']', '', time() - 3600, '/');
				// Kundendaten bei Bedarf speichern (Mitglied anlegen) oder aktualisieren ... done
				// Sonderfall: nderung der Mail-Adresse ... todo
				// HTML-Mailversand ... done

                $mailer['cartArticle'] = 'Mail2Customer';
                $mailer['to'] = $_REQUEST['content']['e-Mail (text)']['text'];
                $mailer['from'] = $activeModules['cart']['sender'];
                $mailer['confirm'] = sprintf(__('A confirmation was sent <em>%s</em>via e-mail.'),$mailer['to']);
                $mailer['special_header'] = '';
				include (CPO_BASEDIR."mod_cart/includes/mailer.inc.php"); // HTML-Mailversand

                $mailer['cartArticle'] = 'Mail2Admin';
                $mailer['to'] = $activeModules['cart']['recipient'];
                $mailer['from'] = $_REQUEST['content']['e-Mail (text)']['text'];
                $mailer['confirm'] = '';
                $mailer['special_header'] = '';
				include (CPO_BASEDIR."mod_cart/includes/mailer.inc.php"); // HTML-Mailversand

				if ($_REQUEST['content']['Password (text)']['text'])  { //Kundendaten speichern
					// on creation check if user already exists
					$edit_user = false;
					$db = new db;
					$db->query('SELECT id, passwd '
							  .'FROM '.CPO_USER.' '
							  ."WHERE user='".addslashes($_REQUEST['content']['e-Mail (text)']['text'])."' "
							  ."AND passwd='".addslashes(md5($_REQUEST['content']['Password (text)']['text']))."'");
					if ($db->next_record()) {
						$edit_user = true;
					}

					if ($edit_user)  {
						// edit user 
						$query = 'UPDATE '.CPO_USER.' SET '
								."user = '".addslashes($_REQUEST['content']['e-Mail (text)']['text'])."', "
								."name = '".addslashes($_REQUEST['content']['e-Mail (text)']['text'])."', "
								."initial = '', "
								."email = '".addslashes($_REQUEST['content']['e-Mail (text)']['text'])."', "
								."language = '".$cpoSystem['language']."', "
								."admin = '".ROLE_MEMBER."', "
								."usergroups_id = '' ";
						$query .= " WHERE id='".addslashes($db->v('id'))."'";
						$db->query($query);
						$message[] = sprintf(__('The user %s was successfully modified.'),
										'<em>'.$_REQUEST['content']['e-Mail (text)']['text'].'</em>');
						logaction('[SHOP] edit user', 'Customer: '.$_REQUEST['content']['e-Mail (text)']['text']);

						// hier noch die Userdaten im Artikel anpassen
					} else {
						// create user
						if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_USER.' WRITE');

						// find maximum id manually as it foobars with auto_increment and negative values
						$db->query('SELECT MAX(ABS(id))+1 as newid FROM '.CPO_USER.' ');
						$db->next_record();
						$newid = $db->v('newid');

						$query = "INSERT INTO ".CPO_USER." "
								."(id, user, name, initial, email, language, admin, usergroups_id, passwd) VALUES (" //, c_time, changer) VALUES ("
								.(int)$newid.', '
								."'".addslashes($_REQUEST['content']['e-Mail (text)']['text'])."', "
								."'".addslashes($_REQUEST['content']['e-Mail (text)']['text'])."', "
								."'', "
								."'".addslashes($_REQUEST['content']['e-Mail (text)']['text'])."', "
								."'".$cpoSystem['language']."', "
								."'".ROLE_MEMBER."', "
								."'', "
								."'".md5($_REQUEST['content']['Password (text)']['text'])."') ";
						$db->query($query);
						if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

						$message[] = sprintf(__('The user %s was successfully created.'),
										'<em>'.$_REQUEST['content']['e-Mail (text)']['text'].'</em>');

						logaction('[SHOP] create user', 'Customer: '.$_REQUEST['content']['e-Mail (text)']['text']);
					}
					// hier noch die Userdaten im Artikel speichern
					$db_nr = '';
					$query = "SELECT nr "
								. "FROM " . CPO_NEWS . " "
								. "WHERE " . ( $cpoSystem['release'] ? "artikel_archiv<2 AND freigabe=" . STATE_RELEASED : "artikel_archiv<1 AND freigabe!=" . STATE_BLOCKED ) . " AND pub_datum<='" . date('Y-m-d H:i:s', time()) . "' AND verfallsdatum>='".date('Y-m-d H:i:s', time())."' AND titel = '".$_REQUEST['content']['e-Mail (text)']['text']."' AND rubric_id=".$activeModules['cart']['customers_rubric']." "; 
					$db = new DB; 
					$db->query($query); 
					while($db->next_record()) { 
						$db_nr            = $db->v('nr'); 
					}

					$data = array();
					$data['rubric_id']     = $activeModules['cart']['customers_rubric'];
					$data['titel']         = $_REQUEST['content']['e-Mail (text)']['text'];
					$data['templates_id']  = $activeModules['cart']['customer_template'];
					$data['autor']         = $_REQUEST['content']['e-Mail (text)']['text'];
					$data['idx']           = '';
					$data['keywords']      = '';
					$data['commentary']    = '';
					$data['verfallsdatum'] = '';
					$data['datum']         = '';
					$data['pub_datum']     = '';
					$data['email']         = $_REQUEST['content']['e-Mail (text)']['text'];
					$data['initial']       = '';
					$data['changedBy']     = $_REQUEST['content']['e-Mail (text)']['text'];
					$data['usergroup']     = '';
					$data['content']       = $_SESSION['billdata'];

					$data['nr']            = $db_nr; //******************************************************************
					$data['sort_id']       = '';
					$data['releasedby']    = 'mod_cart';
					$logrelease = '';
					if (!empty($_POST['article_free'])) {
						$data['releasedby'] = $_REQUEST['content']['e-Mail (text)']['text'];
						$logrelease = ' and release';
					}

					save_article($data);

//					$message[] = __('The order data was successfully saved.');
					logaction('[SHOP] save'.$logrelease.' article', 'Customer: '.$_REQUEST['content']['e-Mail (text)']['text']);

				
				}

			} else {
				$views = array('checkout');
				$actions = array('checkout');
				$message[] = __('Please check all the data of your order first and then send your order!'); 
				break;
			}

			$views = array('confirmation');

			break; /// }}} confirmation

	}
}

// circle the views *************************************************

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'billdata': // {{{
		echo getCartHtml('BillingInfo');
		require(CPO_BASEDIR."_include/message.php");
		include(CPO_BASEDIR.$directory.'/includes/form.inc.php');

		// if the user is still logged in, set his username and password...
		if (isset($_SESSION['SID_log_login_id'])) { 
//			echo 'Eingeloggt als: '.$_SESSION['SID_user']['name'].'<br /><a href="member.php?action=logout">ausloggen</a>';

//			echo getCartHtml('OrderHistory');
//            echo '<h3>Bestellhistorie</h3>';
			if (!$_SESSION['billdata']) { 
				$message[] = __('The billing data is not saved yet! You need to save the data before continuing with the next step!');
				require(CPO_BASEDIR."_include/message.php");
			}
			$orderHTML = getCartHtml('OrderHistory');
			$cart_replace = array();
			$cart_with = array();
			$cart_replace[] = '### CART_user ###'; $cart_with[] = $_SESSION['SID_user']['name']; 
			echo str_replace($cart_replace,$cart_with,$orderHTML);
            $pagetype='index';

            $query = "SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer FROM " . CPO_NEWS . "  WHERE " . ( $cpoSystem['release'] ? "artikel_archiv<2 AND freigabe=" . STATE_RELEASED : "artikel_archiv<1 AND freigabe!=" . STATE_BLOCKED ) . " AND pub_datum<='" . date('Y-m-d H:i:s', time()) . "' AND verfallsdatum>='".date('Y-m-d H:i:s', time())."' AND titel = '".$_SESSION['SID_user']['email']."' AND rubric_id = '".$activeModules['cart']['orders_rubric']."' ORDER BY pub_datum DESC "; 
            $db = new DB; 
            $db->query($query); 

            while($db->next_record()) { 

                $db_template      = $db->v('templates_id'); 
    //			$db_template      = $activeModules['cart']['cartrow_template']; 
                $db_nr            = $db->v('nr'); 
                $db_idx           = $db->v('idx'); 
                $db_email         = $db->v('email'); 
                $db_autor         = $db->v('autor'); 
                $db_changer       = $db->v('changer'); 
                $db_pub_datum     = $db->v('pub_datum'); 
                $db_verfallsdatum = $db->v('verfallsdatum'); 
                $db_commentary    = $db->v('commentary'); 
                $db_titel         = $db->v('titel'); 
                $db_initial       = $db->v('initial'); 
                $db_freigabe      = $db->v('freigabe'); 
                $db_rubric_id     = $db->v('rubric_id');
                $db_last_modify   = $db->v('last_modify');
                if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
                    $GLOBALS['lastUpdated'] = strtotime($db_last_modify);
                }
                require(CPO_BASEDIR.'_include/select_template.php'); 
            } 


		} else {
			echo getCartHtml('LoginInfo');
			// this is taken out of tje original CPO login form
			echo '<form method="post" action="member.php">';
			$antiCSRF->printInput('dologin');
			echo '<input type="hidden" name="rubric" value="'.(int)$GLOBALS['cpoRubric']['id'].'">';
			if (!empty($_nview))
				echo '<input type="hidden" name="nview" value="'.htmlspecialchars($_nview).'">';
			echo ___('Please enter your username and password.', $GLOBALS['cpoRubricSettings']['language']).'<br /><br />';
			echo ___('Login:', $GLOBALS['cpoRubricSettings']['language']).'<br />';
			echo '<input type="text" name="username"><br />';
			echo ___('Password:', $GLOBALS['cpoRubricSettings']['language']).'<br />';
			echo '<input type="password" name="password"> ';

			echo '<input type="submit" class="button" value="'.___('log in', $GLOBALS['cpoRubricSettings']['language']).'">';
			echo '<br />';
			if ($GLOBALS['GLOBALS']['cpoSystem']['send_pw']) {
				echo '<a href="'.htmlspecialchars($_SERVER['PHP_SELF']).'?action=password_reset&amp;rubric=' . (int)$GLOBALS['cpoRubric']['id'] . '">'.__('Reset password', $GLOBALS['cpoRubricSettings']['language']).'</a>';
			}
			echo '</form>';
		}


        break; // }}}
    case 'cart': // {{{
		$cart_replace = array();
		$cart_with = array();
		// create placeholders with span to make them changeable
        $cart_replace[] = '### CART_cartcount ###'; $cart_with[] = '<span class="cartcount">'.$cartcount.'</span>'; 
        $cart_replace[] = '### CART_cartweight ###'; $cart_with[] = '<span class="cartweight">'.locZahl($cartweight/$weightFactor).'</span>'; 
        $cart_replace[] = '### CART_cartval ###'; $cart_with[] = '<span class="cartval">'.locZahl($cartval).'</span>'; 

		require(CPO_BASEDIR."_include/message.php");
        $CartTemplates = explode('<!-- CartRow -->',getCartHtml('EditCart'));
        echo str_replace($cart_replace,$cart_with,$CartTemplates[0]);

		// Die Parameter 
		$sortierung = 'titel ASC' ; // Art der Artikelsortierung 

		$pagetype='index';

		$query = "SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer FROM " . CPO_NEWS . " WHERE nr IN (".implode(",",$itemIDs).") ORDER BY ".$sortierung." "; 
		$db = new DB; 
		$db->query($query); 

		while($db->next_record()) { 

//			$db_template      = $db->v('templates_id'); 
			$db_template      = $activeModules['cart']['cartrow_template']; 
			$db_nr            = $db->v('nr'); 
			$db_idx           = $db->v('idx'); 
			$db_email         = $db->v('email'); 
			$db_autor         = $db->v('autor'); 
			$db_changer       = $db->v('changer'); 
			$db_pub_datum     = $db->v('pub_datum'); 
			$db_verfallsdatum = $db->v('verfallsdatum'); 
			$db_commentary    = $db->v('commentary'); 
			$db_titel         = $db->v('titel'); 
			$db_initial       = $db->v('initial'); 
			$db_freigabe      = $db->v('freigabe'); 
			$db_rubric_id     = $db->v('rubric_id');
			$db_last_modify   = $db->v('last_modify');
			if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
				$GLOBALS['lastUpdated'] = strtotime($db_last_modify);
			}
			require(CPO_BASEDIR.'_include/select_template.php'); 
		} 

        echo str_replace($cart_replace,$cart_with,$CartTemplates[1]);
		break; /// }}} cart

	case 'shipping':
		$shippingHTML = getCartHtml('ShippingInfo');
		require(CPO_BASEDIR."_include/message.php");
		$cart_replace = array();
		$cart_with = array();
        $cart_replace[] = '### CART_shipping ###'; $cart_with[] = $shipping_string; 
		echo str_replace($cart_replace,$cart_with,$shippingHTML);
		break; /// }}} shipping

	case 'checkout':
		echo getCartHtml('CheckoutInfo');
		require(CPO_BASEDIR."_include/message.php");
		$stringCustomerData = '';
		$stringArticleData = '';
		$cart_replace = array();
		$cart_with = array();
		$taxValuesStringArray = array();

		$stringCustomerData .= "\n\n\n<!-- Start Kunden-Daten -->\n<div id=\"checkout_customer\">\n";
			$template = $activeModules['cart']['customer_template']; 
			$query = "SELECT * FROM ".CPO_TEMPLATES." "
					."WHERE id='".addslashes($template)."'";
			DEBUG(2, $query, __FILE__, __LINE__);   
			$db_2 = new DB;
			$db_2->query($query);
			$db_2->next_record();
			$template_datei_full = $db_2->v('tpl_detail')."\n";
			$template_datei = $db_2->v('tpl_detail');
			$templates_id = $template;
			$hdlr_parser_content['text'] = array('include: ' . CPO_BASEDIR . 'mod_cart/includes/parser_c_text.inc.php');
			require(CPO_BASEDIR.'_include/parser.php');
			$hdlr_parser_content['text'] = array('include: ' . CPO_BASEDIR . '_include/parser_c_text.inc.php');
			$stringCustomerData .= $template_datei;
		$stringCustomerData .= "\n</div>\n<!-- Ende Kunden-Daten -->\n\n\n";

        $cart_replace[] = '### CART_cartcount ###'; $cart_with[] = $cartcount; 
        $cart_replace[] = '### CART_cartweight ###'; $cart_with[] = locZahl($cartweight/$weightFactor); 
        $cart_replace[] = '### CART_cartval ###'; $cart_with[] = locZahl($cartval); 
        $cart_replace[] = '### CART_total_shipping ###'; $cart_with[] = locZahl($total_shipping); 
        $cart_replace[] = '### CART_shippingTaxString ###'; $cart_with[] = $shippingTaxString; 
        $cart_replace[] = '### CART_netval ###'; $cart_with[] = locZahl($netval); 
        $cart_replace[] = '### CART_shippingNet ###'; $cart_with[] = locZahl($shippingNet); 
//        foreach ($netArray AS $tax=>$val) $taxByNetString .= percent($tax).' von netto '.locZahl($val).' Euro = '.locZahl($taxArray[$tax]).' Euro<br />';
        foreach ($netArray AS $tax=>$val) $taxByNetString .= sprintf(__('%1$s of net %2$s %4$s = %3$s %4$s'),percent($tax),locZahl($val),locZahl($taxArray[$tax]),$activeModules['cart']['currency']).'<br />';
        $cart_replace[] = '### CART_taxByNet ###'; $cart_with[] = $taxByNetString; 
        foreach ($taxArray AS $tax=>$val) $taxesString .= __('VAT').' '.percent($tax).'<br />';
        $cart_replace[] = '### CART_taxes ###'; $cart_with[] = $taxesString.__('VAT total');
        foreach ($taxArray AS $tax=>$val) $taxValuesStringArray[] = locZahl($val+$taxes[$tax]).' '.$activeModules['cart']['currency'];
        $cart_replace[] = '### CART_taxValues ###'; $cart_with[] = implode('<br />',$taxValuesStringArray);
        $cart_replace[] = '### CART_taxTotal ###'; $cart_with[] = locZahl(array_sum($taxArray)+array_sum($taxes));
        $cart_replace[] = '### CART_billTotal ###'; $cart_with[] = locZahl($cartval+$total_shipping);
        
        $stringArticleData .= "\n\n\n<!-- Start Artikel-Daten -->\n<div id=\"checkout_articles\">\n";

        $CartTemplates = explode('<!-- CartRow -->',getCartHtml('ArticleData'));
        $stringArticleData .= str_replace($cart_replace,$cart_with,$CartTemplates[0]);
		
		// Die Parameter 
		$sortierung = 'titel ASC' ; // Art der Artikelsortierung 
		$pagetype='detail';

		$query = "SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer FROM " . CPO_NEWS . " WHERE nr IN (".implode(",",$itemIDs).") ORDER BY ".$sortierung." "; 
		$db = new DB; 
		$db->query($query); 

		while($db->next_record()) { 
			$db_template      = $activeModules['cart']['cartrow_template']; 
			$db_nr            = $db->v('nr'); 
			$db_idx           = $db->v('idx'); 
			$db_email         = $db->v('email'); 
			$db_autor         = $db->v('autor'); 
			$db_changer       = $db->v('changer'); 
			$db_pub_datum     = $db->v('pub_datum'); 
			$db_verfallsdatum = $db->v('verfallsdatum'); 
			$db_commentary    = $db->v('commentary'); 
			$db_titel         = $db->v('titel'); 
			$db_initial       = $db->v('initial'); 
			$db_freigabe      = $db->v('freigabe'); 
			$db_rubric_id     = $db->v('rubric_id');
			$db_last_modify   = $db->v('last_modify');
			if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
				$GLOBALS['lastUpdated'] = strtotime($db_last_modify);
			}
            ob_start();
			require(CPO_BASEDIR.'_include/select_template.php');
            $stringArticleData .= ob_get_clean();
		} 

        $stringArticleData .= str_replace($cart_replace,$cart_with,$CartTemplates[1]);

        $stringArticleData .= "\n</div>\n<!-- Ende Artikel-Daten -->\n\n\n";

        echo $stringCustomerData;
        echo $stringArticleData;

        $_REQUEST['e-Mail'] = $_SESSION['billdata']['e-Mail (text)']['text']; 
        $_REQUEST['Count'] = $cartcount; 
        $_REQUEST['Total'] = locZahl($cartval+$total_shipping); 
		$_REQUEST['content']['Customer-Data (html)']['html'] = 'xxx';
		$_REQUEST['content']['Article-Data (html)']['html'] = 'xxx';
		
		unset($fetchedcontent,$placeholders_cache,$parsed_form); // Cache lschen! // Formular frisch fllen!

		include(CPO_BASEDIR.$directory.'/includes/form.inc.php');
        
        
        
        $pagetype='index';
        break; /// }}} checkout

	case 'confirmation':
		require(CPO_BASEDIR."_include/message.php");
		echo '<script type="text/javascript">resetCart();refreshCartDisplay();</script>'."\n";
		echo getCartHtml('ConfirmationInfo');
		break; /// }}} confirmation

	}
	$_REQUEST['view'] = $nextview;
}

$directory = $orgDirectory;
